<template>
  <top-navbar @toggleTaskList="taskListVisible = $event">
    <template v-slot:tasklist>
      <div
        key="task-list-container"
        :class="`task-list-container ${
          taskListVisible ? 'task-list-visible' : ''
        }`"
      >
        <task-list ref="taskList" key="task-list" />
      </div>
    </template>
  </top-navbar>
  <div class="container">
    <div class="row">
      <router-view />
    </div>
    <notification-area ref="notificationArea" />
    <transition name="fade">
      <div
        v-if="!warningHidden"
        class="alert alert-warning"
        id="beta-warning"
        role="alert"
      >
        <i class="fas fa-exclamation-triangle"></i>
        Beta version of the Flow UI - not everything works perfectly
        <button
          type="button"
          class="btn-close"
          aria-label="Close"
          title="Hide for 1 month"
          @click="hideWarning"
        ></button>
      </div>
    </transition>
    <transition name="fade">
      <progress-spinner style="z-index: 10000" v-if="bodyDisabled" />
    </transition>
  </div>
</template>

<script>
import "@/assets/style.scss";
import TopNavbar from "@/components/TopNavbar";
import NotificationArea from "@/components/NotificationArea";
import TaskList from "@/components/TaskList";

// max hide time in ms (defaults to 30 days)
const warningMaxHideTime = 3600 * 24 * 30 * 1000;

export default {
  name: "App",
  methods: {
    hideWarning() {
      this.warningHidden = true;
      localStorage.setItem("flowuiWarningHidden", "true");
      localStorage.setItem("flowuiWarningHiddenAt", new Date().toISOString());
    },
    toggleProgressSpinner(status) {
      this.bodyDisabled = !!status;
    },
  },
  provide() {
    return {
      toggleProgressSpinner: this.toggleProgressSpinner,
    };
  },
  data() {
    let warningHidden = localStorage.getItem("flowuiWarningHidden") === "true";
    if (warningHidden) {
      const warningHiddenAt = new Date(
        localStorage.getItem("flowuiWarningHiddenAt") || "1970-01-01"
      );
      if (new Date() - warningHiddenAt >= warningMaxHideTime) {
        warningHidden = false;
        localStorage.removeItem("flowuiWarningHiddenAt");
        localStorage.removeItem("flowuiWarningHidden");
      }

      // console.log({ warningHiddenAt });
    }
    return {
      taskListVisible: false,
      warningHidden,
      bodyDisabled: false,
    };
  },
  components: { TopNavbar, NotificationArea, TaskList },
};
</script>

<style lang="scss">
@keyframes rotate-cog {
  from {
    transform: rotate(0deg);
  }
  to {
    transform: rotate(360deg);
  }
}

h4.alert-heading {
  i {
    margin-right: 1rem;
  }
}

.fade {
  &-enter-active,
  &-leave-active {
    transition: opacity 500ms ease;
  }

  &-enter-from,
  &-leave-to {
    opacity: 0;
  }
}

a {
  text-decoration: none;
}

a.badge.bg-secondary {
  text-decoration: none;
  font-weight: 500;

  &:hover {
    color: black;
  }
}
#beta-warning {
  position: fixed;
  bottom: 0px;
  left: 50%;
  transform: translate(-50%, 0);
  margin: 0 auto;
  width: clamp(250px, 720px, 100vw);
  text-align: center;
  button {
    float: right;
  }
}
</style>
